#include <bits/stdc++.h>

#include "testlib.h"

using namespace std;

map<string, string> params;

long long get(string name, long long def = 0) {
    if (params.count(name)) {
        if (params[name].find('e') != string::npos) {
            return (long long)(stod(params[name]));
        }
        return stoll(params[name]);
    } else {
        return def;
    }
}

void put(vector<int>& output) {
    int n = output.size();
    for (int i = 0; i < n; ++i) {
        cout << output[i] << ((i == n - 1) ? "" : " ");
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);
    for (int i = 1; i < argc; i++) {
        string s = string(argv[i]);
        if (s.find("=") != string::npos) {
            auto pos = s.find("=");
            params[s.substr(0, pos)] = s.substr(pos + 1);
        } else {
            params[s] = "";
        }
    }

    int n = get("n", 1);
    int k = get("k", 1);
    int t = get("t", 1);
    int maxA = get("maxA", 1);
    int block_size = get("block_size", 1);
    int nubmer_to_shuffle = get("shuffle_count", 1);
    cout << n << " " << k << " " << t << '\n';
    vector<int> ans;
    vector<int> to_ans;
    int kk = 1;
    for (int i = 0; i < n; ++kk) {
        int c = rnd.next(1, maxA);
        for (int j = 0; i < n && j < block_size; ++j, ++i) {
            to_ans.emplace_back(c);
        }
        if (kk % nubmer_to_shuffle == 0) {
            shuffle(to_ans.begin(), to_ans.end());
            for (auto& i : to_ans) {
                ans.push_back(i);
            }
            to_ans.clear();
        }
    }
    shuffle(to_ans.begin(), to_ans.end());
    for (auto& i : to_ans) {
        ans.push_back(i);
    }
    to_ans.clear();
    put(ans);
    cout << '\n';
}
