#include <bits/stdc++.h>

using namespace std;

#define all(x) x.begin(), x.end()
#define rall(x) x.rbegin(), x.rend()
typedef long long ll;
typedef double db;
typedef unsigned long long ull;

inline void fast_io() {
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
}

void decrease_key(unordered_map<int, int> &mp, int key) {
    mp[key]--;
    if (mp[key] == 0) {
        mp.erase(key);
    }
}

vector<vector<ll>> binup;

void count_dp(int n, int k, int t, vector<pair<int, int>> &dp,
              vector<int> &doubled) {
    unordered_map<int, int> cnt;
    int l = n - 1, r = n - 1;
    for (r = n - 1; r < 2 * n; ++r) {
        cnt[doubled[r]]++;
        if (cnt.size() > t) {
            decrease_key(cnt, doubled[r]);
            --r;
            break;
        }
    }
    if (r == 2 * n) {
        cout << 1;
        exit(0);
    }
    for (; l >= 0;) {
        if (r >= n - 1) {
            dp[l] = {r + 1, 1};
        } else {
            dp[l] = {dp[r + 1].first, dp[r + 1].second + 1};
        }
        --l;
        cnt[doubled[l]]++;
        while (cnt.size() > t) {
            decrease_key(cnt, doubled[r]);
            --r;
        }
    }
}

void count_binup(int n, int k, int lg, vector<pair<int, int>> &dp) {
    int p = 0;
    for (int i = 0; i < k; ++i) {
        binup[0][i] = dp[p].second;
        p = dp[p].first % n;
    }
    for (int c = 1; c < lg; ++c) {
        for (int i = 0; i < k; ++i) {
            if (i + (1 << (c - 1)) >= k || i + (1 << c) > k) {
                continue;
            }
            binup[c][i] = binup[c - 1][i] + binup[c - 1][i + (1 << (c - 1))];
        }
    }
}

ll count_ans(int k, int lg) {
    int ind = 0;
    ll ans = 0;
    for (int c = lg - 1; c >= 0; --c) {
        if (ind + (1 << c) <= k) {
            ans += binup[c][ind];
            ind += (1 << c);
        }
    }
    return ans;
}

int main() {
    fast_io();
    int n, k, t;
    cin >> n >> k >> t;
    vector<int> a(n);
    for (auto &i : a) {
        cin >> i;
    }
    vector<pair<int, int>> dp(n);
    binup.resize(log2(k) + 2, vector<ll>(k));
    vector<int> doubled(n * 2);
    for (int i = 0; i < 2 * n; ++i) {
        doubled[i] = a[i % n];
    }
    count_dp(n, k, t, dp, doubled);
    count_binup(n, k, log2(k) + 2, dp);
    cout << count_ans(k, log2(k) + 2);
}
